=== test/unit/table/Makefile ===
###############################################################################
#
# Makefile for libxlsxwriter library.
#
# Copyright 2014-2024, John McNamara, jmcnamara@cpan.org
#

include ../Makefile.unit
